/* vim: set tabstop=4 shiftwidth=4 softtabstop=4: */
/*
 * Copyright 2007 the original author or authors.
 * 
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * 
 * 	http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package jp.sourceforge.webframe.webconsole.action;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import jp.sourceforge.webframe.struts.util.StrutsUtils;

import org.apache.struts.action.Action;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;
import org.apache.struts.config.ActionConfig;
import org.apache.struts.config.ModuleConfig;

/**
 * StrutsActionDetailsAction
 *
 * @author Yomei Komiya
 * @since 0.9.2
 *
 * $Id$
 */
public class StrutsActionDetailsAction extends Action {

	public ActionForward execute(
			ActionMapping mapping,
			ActionForm actionForm,
			HttpServletRequest request,
			HttpServletResponse response) throws Exception {
		
		String prefix = null;
		String path = null;
		ActionConfig actionConfig = null;
		try {
			prefix = request.getParameter("prefix");
			path = request.getParameter("path");
			if (prefix != null && path != null) {
				ModuleConfig moduleConfig = StrutsUtils.getModuleConfig(prefix, this);
				if (moduleConfig != null) {
					actionConfig = moduleConfig.findActionConfig(path);
				}
			}
			else {
				throw new IllegalArgumentException(
						"Both prefix and path is required.");
			}
		}
		catch (Exception e) {
			e.printStackTrace();
			request.setAttribute("errorMessage", e.getMessage());
			
			return mapping.findForward("failure");
		}
		finally {
			request.setAttribute("actionConfig", actionConfig);
		}
		
		return mapping.findForward("strutsActionDetails");
	}

}
